<?php

#
# Redirector 3.4
#
# Weiterleiten auf eine einer Variablen zugeordneten Adresse
#
# Autor:            Patrick Canterino <patrick@patshaping.de>
# Letzte Aenderung: 24.8.2008
#
# Copyright (C) 2001-2008 Patrick Canterino
#
# Diese Datei kann unter den Bedingungen der "Artistic License 1.0"
# weitergegeben und / oder veraendert werden.
# Siehe:
# http://www.opensource.org/licenses/artistic-license-1.0.php
#

# Einstellungen

$config    = 'redirect.dat';
$delimiter = '|';
$errorpath = 'errors';

# Ende Einstellungen

$errorpath = str_replace('\\','/',$errorpath);
$errorpath = preg_replace('!/+$!','',$errorpath);

$page = formdata('page');

if(!file_exists($config)) showhtml("$errorpath/no_datafile.htm",'500 Internal Server Error');
if(!$page)                showhtml("$errorpath/no_data.htm",'500 Internal Server Error');

$lines = file($config);

foreach($lines as $line)
{
 $line = preg_replace('/\s/','',$line);

 if($line == '')     continue;
 if($line[0] == '#') continue;

 list($name,$url) = explode($delimiter,$line,2);

 if($name == $page)
 {
  if(!$url) showhtml("$errorpath/no_url.htm",'500 Internal Server Error');

  header('HTTP/1.0 301 Moved Permanently');
  header("Location: $url");
  exit;
 }
}

showhtml("$errorpath/invalid_var.htm",'404 Not Found');

# formdata()
#
# Formulardaten bei deaktiviertem register_globals auslesen
#
# Parameter:   Name des Formularfeldes
#
# Rueckgabe:   Inhalt des Formularfeldes (String oder Array)
#
# Bemerkungen: - Wenn der HTTP-Zugriff nicht POST oder GET ist,
#                wird nichts zurueckgegeben.
#              - Codierende Backslashes werden automatisch entfernt

function formdata($param)
{
 switch($_SERVER['REQUEST_METHOD'])
 {
  case 'GET':
   if(isset($_GET[$param]))
   {
    $value = $_GET[$param];
    break;
   }
   else return null;

  case 'POST':
   if(isset($_POST[$param]))
   {
    $value = $_POST[$param];
    break;
   }
   else return null;

  default:
   return null;
 }

 if(get_magic_quotes_gpc())
 {
  if(is_array($value)) return array_map('stripslashes',$value);
  else return stripslashes($value);
 }
 else return $value;
}

# showhtml()
#
# HTML-Datei anzeigen und Script beenden
#
# Parameter: 1. HTML-Datei
#            2. HTTP-Status-Header (Standard: '' --> wird nicht gesendet)

function showhtml($file,$status='')
{
 if($status != '')
 {
  header('HTTP/1.0 '.$status);
 }

 readfile($file);
 exit;
}

?>